unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Gbase, Grids, GStandContr, GSpreader, StdCtrls, GPositioners, GExtContr,
  Menus;

type
  TForm1 = class(TForm)
    Gbase1: TGbase;
    GSpreader1: TGSpreader;
    GGrid1: TGGrid;
    GComboBox1: TGComboBox;
    GScroll1: TGScrollPositioner;
    Label1: TLabel;
    GLabel1: TGLabel;
    GMemo1: TGMemo;
    GLabel2: TGLabel;
    MainMenu1: TMainMenu;
    addbook: TMenuItem;
    delbook: TMenuItem;
    Indekswg1: TMenuItem;
    title1: TMenuItem;
    Author1: TMenuItem;
    tema1: TMenuItem;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Lfind: TLabel;
    Edit1: TEdit;
    procedure Gbase1BeforeOpen(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure addbookClick(Sender: TObject);
    procedure delbookClick(Sender: TObject);
    procedure title1Click(Sender: TObject);
    procedure Author1Click(Sender: TObject);
    procedure tema1Click(Sender: TObject);
    procedure Gbase1BeforeDelete(Sender: TObject; var GoDelete: Boolean);
    procedure edit1Change(Sender: TObject);
    procedure Gbase1Positioning(Sender: TObject; const NewRecNo: Cardinal);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Gbase1BeforeOpen(Sender: TObject);
begin
  GGrid1.SetColumnsOrder([2,1,3,4],true);
  GGrid1.SetColumnsSize([60,170,140,80]);
  GSpreader1.AddStdReceivers([],[GLabel1,GLabel2],[GGrid1],[GComboBox1]);
  GSpreader1.AddExtReceivers([GMemo1],[]);
  GSpreader1.AddPosReceivers([GScroll1],[]);
end;

procedure TForm1.Gbase1Positioning(Sender: TObject;
  const NewRecNo: Cardinal);
begin
  GSpreader1.Spread(NewRecNo);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  GBase1.Open('author');
  author1.Click;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Gbase1.Close;
end;

procedure TForm1.addbookClick(Sender: TObject);
begin
  GBase1.Append;
end;

procedure TForm1.delbookClick(Sender: TObject);
begin
  GBase1.Delete;
end;

procedure TForm1.title1Click(Sender: TObject);
begin
  GBase1.IndexOn('title');
  Label2.Caption:='sorted on books title';
  Lfind.Caption:='Find title'
end;

procedure TForm1.Author1Click(Sender: TObject);
begin
  GBase1.IndexOn('author');
  Label2.Caption:='sorted on books author';
  Lfind.Caption:='Find author'
end;

procedure TForm1.tema1Click(Sender: TObject);
begin
  GBase1.IndexOn(4);
  Label2.Caption:='sorted on books matter';
  Lfind.Caption:='Find subject'
end;

procedure TForm1.Gbase1BeforeDelete(Sender: TObject;
  var GoDelete: Boolean);
begin
  if MessageDlg('Really delete?', mtConfirmation, [mbYes, mbNo], 0) <> mrYes then
    GoDelete:=false;
end;

procedure TForm1.edit1Change(Sender: TObject);
var name: string[255];
begin
  name:=edit1.Text;
  case gbase1.ActiveIndex of
    1: gbase1.FindFirst('title',@name,'p');
    3: gbase1.FindFirst('author',@name,'p');
    4: gbase1.FindFirst('subject',@name,'p');
  end;
end;

end.
